package de.ivu.elect.business.benutzerverwaltung.entity;

import de.ivu.elect.jee.presentation.dynamicform.Property;

@javax.enterprise.inject.Vetoed
public class RolleProperties
{

private final Rolle entity;


    
    private
                de.ivu.elect.jee.presentation.dynamicform.LambdaStringProperty
                  beschreibungProperty;

        
        
    private
                de.ivu.elect.jee.presentation.dynamicform.LambdaStringProperty
                  nameProperty;

        
        
    private
                de.ivu.elect.jee.presentation.dynamicform.LambdaEnumProperty<de.ivu.elect.business.benutzerverwaltung.entity.RolleArt>
                  rolleArtProperty;

                private de.ivu.elect.jee.presentation.dynamicform.LambdaEnumProperty<de.ivu.elect.business.benutzerverwaltung.entity.RolleArt> rolleArtMitLeererAuswahlProperty;
        
    

public RolleProperties(Rolle entity) {
this.entity = entity;

}

private static RolleMeta getMetaData() {
return de.ivu.elect.jee.cdi.BeanManagerUtil.getBeanByClass( RolleMeta.class);
}


    

        public
                    de.ivu.elect.jee.presentation.dynamicform.AbstractStringProperty
                getBeschreibungProperty() {
        if (beschreibungProperty == null) {
        beschreibungProperty = new


                    de.ivu.elect.jee.presentation.dynamicform.LambdaStringProperty
        
        (
        getMetaData().getBeschreibungEinzahlMessage(),
        getMetaData().getBeschreibungDefaultValue(),
        getMetaData().isBeschreibungRequired(),
                entity::setBeschreibung,
        entity::getBeschreibung

                    , 0 ,
            de.ivu.elect.business.benutzerverwaltung.entity.RolleConstants.BESCHREIBUNG_MAX_LENGTH
                );

        }


        return beschreibungProperty;
        }





        
        

        public
                    de.ivu.elect.jee.presentation.dynamicform.AbstractStringProperty
                getNameProperty() {
        if (nameProperty == null) {
        nameProperty = new


                    de.ivu.elect.jee.presentation.dynamicform.LambdaStringProperty
        
        (
        getMetaData().getNameEinzahlMessage(),
        getMetaData().getNameDefaultValue(),
        getMetaData().isNameRequired(),
                entity::setName,
        entity::getName

                    ,  1 ,
            de.ivu.elect.business.benutzerverwaltung.entity.RolleConstants.NAME_MAX_LENGTH
                );

        }


        return nameProperty;
        }





        
        

        public
                    de.ivu.elect.jee.presentation.dynamicform.LambdaEnumProperty<de.ivu.elect.business.benutzerverwaltung.entity.RolleArt>
                getRolleArtProperty() {
        if (rolleArtProperty == null) {
        rolleArtProperty = new


                    de.ivu.elect.jee.presentation.dynamicform.LambdaEnumProperty<>
        
        (
        getMetaData().getRolleArtEinzahlMessage(),
        getMetaData().getRolleArtDefaultValue(),
        getMetaData().isRolleArtRequired(),
                entity::setRolleArt,
        entity::getRolleArt

                    , de.ivu.elect.business.benutzerverwaltung.entity.RolleArt.class,
            java.util.Arrays.asList(de.ivu.elect.business.benutzerverwaltung.entity.RolleArt.values()).stream().sorted(Enum::compareTo).collect(java.util.stream.Collectors.toList())
                );

        }


        return rolleArtProperty;
        }





        

            public de.ivu.elect.jee.presentation.dynamicform.LambdaEnumProperty<de.ivu.elect.business.benutzerverwaltung.entity.RolleArt> getRolleArtMitLeererAuswahlProperty() {
               if (rolleArtMitLeererAuswahlProperty == null) {
                 rolleArtMitLeererAuswahlProperty = new
                de.ivu.elect.jee.presentation.dynamicform.LambdaEnumProperty<>
                    (
                        getMetaData().getRolleArtEinzahlMessage(),
        				getMetaData().getRolleArtDefaultValue(),
                        getMetaData().isRolleArtRequired(),
                        entity::setRolleArt,
                        entity::getRolleArt
                        , de.ivu.elect.business.benutzerverwaltung.entity.RolleArt.class,
                        java.util.Arrays.asList(de.ivu.elect.business.benutzerverwaltung.entity.RolleArt.values()).stream().sorted(Enum::compareTo).collect(java.util.stream.Collectors.toList())
                        ,true
                    );
            }

               return rolleArtMitLeererAuswahlProperty;
            }
        
        }